(define count 0)

(define zufall
  (lambda (a b)
    (+ (random (- b a -1)) a)))

(define zufallsliste
  (lambda (a b n)
    (if (= n 0)
        ()
        (cons (zufall a b) (zufallsliste a b (- n 1))))))
;------------------------------------------------------------
(define zerlegen
  (lambda (x ls symb)
    (if (null? ls)
        (list () ())
        (let ([tls (zerlegen x (cdr ls) symb)])
          (if (symb (car ls) x)
              (list (cons (car ls) (car tls)) (cadr tls))
              (list (car tls) (cons (car ls) (cadr tls))))))))

(define quicksort
  (lambda (ls symb)
    (if (null? ls)
        ()
        (let ([tls (zerlegen (car ls) (cdr ls) symb)])
          (append (quicksort (car tls) symb) (list (car ls)) (quicksort (cadr tls) symb))))))

(define quicksort-aufwand
  (lambda (ls symb)
    (letrec
      ([zerlege
        (lambda (x ls)
          (if (null? ls)
              (list () ())
              (let ([tls (zerlege x (cdr ls))])
                (set! count (+ 1 count)) ;Zerlegen in Teillisten
                (if (symb (car ls) x)
                    (list (cons (car ls) (car tls)) (cadr tls))
                    (list (car tls) (cons (car ls) (cadr tls)))))))])
      (if (null? ls)
          ()
          (let ([tls (zerlege (car ls) (cdr ls))])
            (set! count (+ 1 count)) ;Zusammensetzen der Teillisten
            (append (quicksort-aufwand (car tls) symb) 
                    (list (car ls))
                    (quicksort-aufwand (cadr tls) symb)))))))
;------------------------------------------------------------
(define experiment
  (lambda (von bis anzahl)
    (let ([zufliste (zufallsliste von bis anzahl)])
      (set! count 0)
      (printf "Unsortierte Zufallsliste: ~n")
      (printf "~s ~n" zufliste)
      (printf "Sortierte Zufallsliste: ~n")
      (printf "~s ~n" (quicksort-aufwand zufliste <))
      (printf "Quicksort, Anzahl der Zerlegungen und Zusammensetzungen: ~s ~n" count))))

(define mehrfachexperiment
  (lambda (von bis anzahl wiederholung)
    (letrec ([durchfuehren
              (lambda (whlg sum)
                (set! count 0)
                (quicksort-aufwand (zufallsliste von bis anzahl) <)
                (if (= whlg 1)
                    (+ sum count)
                    (durchfuehren (- whlg 1) (+ sum count))))])
        (printf "Quicksort, mittlere Anzahl der Zerlegungen und Zusammensetzungen: ~s ~n" 
                (/ (durchfuehren wiederholung 0) wiederholung)))))

